/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_COMBINE_SOURCE_H_INCLUDED_)
#define _HARKLIB_NODE_COMBINE_SOURCE_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"
#include "hark-lib/source.h"

namespace hark
{
namespace node
{
    class CombineSource: public NodeDef
    {
    public:
        CombineSource();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        enum class HANDLING_MODE : int64_t {
            IGNORE = 0,
            PRIORITIZE_SOURCE1 = 1,
            PRIORITIZE_SOURCE2 = 2,
            USE_OFFSET = 3
        };
        HANDLING_MODE handling_mode;
        int source1_offset;
        int source2_offset;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_COMBINE_SOURCE_H_INCLUDED_) */

/* end of file */
