/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_CONSTANT_LOCALIZATION_H_INCLUDED_)
#define _HARKLIB_NODE_CONSTANT_LOCALIZATION_H_INCLUDED_ 1

#include <vector>
#include <climits>
#include <cmath>

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

#include "hark-lib/source.h"

namespace hark
{
namespace node
{
    class ConstantLocalization: public NodeDef
    {
    public:
        ConstantLocalization();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        const float coef = 3.141592653589793238462643383279502884L / 180.0f;

        std::vector<float> angles;
        std::vector<float> elevations;
        std::vector<float> power;
        int min_id;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_CONSTANT_LOCALIZATION_H_INCLUDED_) */

/* end of file */
