/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_ESTIMATE_LEAK_H_INCLUDED_)
#define _HARKLIB_NODE_ESTIMATE_LEAK_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

#include <string>
#include <vector>
#include <complex>

namespace hark
{
namespace node
{
    class EstimateLeak: public NodeDef
    {
    public:
        EstimateLeak();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        float leak_factor;
        float over_cancel_factor;

        float alpha;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_ESTIMATE_LEAK_H_INCLUDED_) */

/* end of file */
