/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_FEATURE_REMOVER_H_INCLUDED_)
#define _HARKLIB_NODE_FEATURE_REMOVER_H_INCLUDED_ 1

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

#include <vector>

namespace hark
{
namespace node
{
    class FeatureRemover: public NodeDef
    {
    public:
        FeatureRemover();
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        void initialize(InputDataBundle &input);

    private:
        std::vector<size_t>_id_tobe_removed;

    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_FEATURE_REMOVER_H_INCLUDED_) */

/* end of file */
