/*
   HARK Library
   Copyright (C) 2021 Honda Research Institute Japan Inc.
 */

#if !defined(_HARKLIB_NODE_SOURCE_TRACKER_H_INCLUDED_)
#define _HARKLIB_NODE_SOURCE_TRACKER_H_INCLUDED_ 1

#include <vector>
#include <climits>
#include <limits>

#include "hark-lib/hark-lib.h"
#include "hark-lib/node.h"

#include "hark-lib/source.h"

namespace hark
{
namespace node
{
    class SourceTracker: public NodeDef
    {
    public:
        SourceTracker();

        void initialize(InputDataBundle &input);
        virtual void reset();
        virtual bool operator () (size_t count, InputDataBundle &input, OutputDataBundle &output);

    private:
        const float coef_deg2rad = 3.141592653589793238462643383279502884L / 180.0f;
        Source::CompareMode compare_mode;
        float thresh;
        float pause_length;
        float min_source_interval; // degree for set prameter
        float min_source_interval_rad; // radian for fast calculate
        float min_tfindex_interval;
        int next_id;
        bool debug;
        std::vector<data> last_sources;
    };
}
}

#endif /* #if !defined(_HARKLIB_NODE_SOURCE_TRACKER_H_INCLUDED_) */

/* end of file */
